;SML pipe dwelling bullet bill blaster
;by smkdan
;GFX from andyk250

DIR = $03
PROPRAM = $04
TEMP = $09

;C2: timer
;1602: state

IDLEHIDE = $00
RISING = $01
FIREWAITA = $02
FIRE = $03
FIREWAITB = $04
SINKING = $05

HIDEDELAY = $40
FIREDELAY = $20
FIRESOUND = $09

dcb "INIT"
	LDA $E4,x	;add 8 to xpos
	CLC
	ADC #$08
	STA $E4,x
	LDA $14E0,x
	ADC #$00
	STA $14E0,x

;start in hiding, timer at delay
	LDA #HIDEDELAY
	STA $C2,x

	RTL

dcb "MAIN"
	PHB
	PHK
	PLB
	JSR Run
	PLB
	RTL


Return_l
	RTS

Run
	JSR SUB_OFF_SCREEN_X0
	JSR GET_DRAW_INFO
	JSR GFX			;draw sprite

	LDA $14C8,x
	CMP #$08          	 
	BNE Return_l           
	LDA $9D 		;locked sprites?
	BNE Return_l
	LDA $15D0,x		;yoshi eating?
	BNE Return_l

	JSR SOLIDITY	;solid

	LDA $1602,x	;load state
	CMP #IDLEHIDE
	BEQ DoIdleHide
	CMP #RISING
	BEQ DoRise
	CMP #FIREWAITA
	BEQ DoFireWaitA
	CMP #FIRE
	BEQ DoFire
	CMP #FIREWAITB
	BEQ DoFireWaitB
	CMP #SINKING
	BEQ DoSinking

DoIdleHide
	DEC $C2,x	;decrement timer
	BNE Continue1

	LDA #RISING	;set to rise
	STA $1602,x
	LDA #$10	;fixed timer
	STA $C2,x

Continue1
	RTS

DoRise
	DEC $C2,x	;decrement timer
	BNE Continue2

	LDA #FIREWAITA
	STA $1602,x
	LDA #FIREDELAY
	STA $C2,x
	RTS
	
Continue2
	LDA $D8,x	;ypos--
	SEC
	SBC #$02
	STA $D8,x
	LDA $14D4,x
	SBC #$00
	STA $14D4,x

	RTS

DoFireWaitA
	DEC $C2,x	;dec t
	BNE Continue1

	LDA #FIRE
	STA $1602,x
	RTS

DoFire
	JSR GenerateStd	;generate sprite
	LDA #FIRESOUND	;sound effect
	STA $1DFC

	LDA #FIREWAITB
	STA $1602,x
	LDA #FIREDELAY
	STA $C2,x

	RTS

DoFireWaitB
	DEC $C2,x	;dec t
	BNE Continue1

	LDA #SINKING
	STA $1602,x
	LDA #$10	;fixed sink/rise timer
	STA $C2,x

	RTS

DoSinking
	DEC $C2,x	;dext
	BNE Continue3

	LDA #IDLEHIDE
	STA $C2,x
	LDA #HIDEDELAY
	STA $1602,x

	RTS

Continue3
	LDA $D8,x	;ypos--
	CLC
	ADC #$02
	STA $D8,x
	LDA $14D4,x
	ADC #$00
	STA $14D4,x

	RTS

Return
	RTS        
			
;=====

TILEMAP	dcb $8D,$AD	;2 tiles
	
YDISP	dcb $00,$10

GFX
	LDA $157C,x	;direction...
	STA DIR

	LDA $15F6,x	;properties...
	STA PROPRAM

	LDX #$00	;reset loop counter

OAM_Loop
	LDA $00
	STA $0300,y	;single xpos

	LDA $01
	CLC
	ADC YDISP,x
	STA $0301,y	;ypos

	LDA TILEMAP,x
	STA $0302,y	;chr

	LDA PROPRAM
	STA $0303,y	;properties

	INY
	INY
	INY
	INY
	
	INX
	CPX #$02	;2 tiles
	BNE OAM_Loop

	LDX $15E9	;restore sprite index
	LDY #$02	;16x16
        LDA #$01        ;2 tiles
        JSL $01B7B3	;reserve

	RTS

;generate standard
;======================

SPRITE_GEN = $1C

GENPOS	dcw $0010,$FFF0

GenerateStd	
	JSL $02A9E4		;grab free sprite slot
	BMI ReturnGC		;return if none left...

	LDA #$08
	STA $14C8,y		;normal status, run init routine?

	LDA #SPRITE_GEN		;load sprite to generate...
	STA $9E,y		;and restore  

	LDA $E4,x		;store 16bits xposition at $00
	STA $00
	LDA $14E0,x
	STA $01

	PHY
	JSR SUB_HORZ_POS	;genpos depending on size
	TYA
	ASL A			;16bits
	TAY
	LDA GENPOS,y
	CLC
	ADC $00
	PLY

	STA $E4,y		;store xpositions
	XBA
	STA $14E0,y

	LDA $D8,x		;store yposition
	STA $D8,y		;Ypos
	LDA $14D4,x
	STA $14D4,y		;same screen

	PHX
	TYX			;new sprite slot into X
	JSL $07F7D2		;create
	PLX

	PHY
	JSR SUB_HORZ_POS	;direction based on mario side
	TYA
	PLY
	STA $C2,y

	LDA $E4,y		;xpos low
	STA $00
	LDA $D8,y		;ypos low
	STA $01
	JSR SUB_SMOKE		;make some smoke
		
ReturnGC
	RTS  
	
;my solid routine

XDISPS = $FFF2		;xpos relative to spritex
YDISPS = $0000	
WIDTH = $000E		;width of interaction field
HEIGHT = $0020

SOLIDITY
	PHP		;preserve status
	SEP #$30	;8bit AXY
	STZ $00		;reset scratch ram used here
	STZ $01
	STZ $02

;optional yoshi displacement
	LDY #$E0	;yoshiless displacement
	LDA $187A	;yoshi flag
	BEQ NoYoshiB
	LDY #$D0	;yoshi displacement
NoYoshiB
	TYA		;Y->A
	STA $04
	LDA #$FF	;signed
	STA $05

;test left edge
	LDA $14E0,x	;xhigh
	XBA
	LDA $E4,x	;xlow
	REP #$20	;16bit A
	CLC
	ADC.w #XDISPS	;add displacement word
	CMP $94		;compare mario x
	SEP #$20	;8bit A again
	BCS HorzOut	;if Mario's X is smaller, then mario is to the left of sprite

;within from left, test right
	LDA $14E0,x	;load x positions again
	XBA
	LDA $E4,x
	REP #$20	;16bit A
	CLC
	ADC.w #WIDTH	;add width, test right
	STA $00		;scratch
	LDA $94		;load mario X
	CMP $00		;compare operated value
	SEP #$20	;8bit A again
	BCS HorzOut

	LDA #$01	;within horizontal range, set bit0 of $02
	TSB $02

HorzOut			;skip label for horizontal range, now test vertical range
;test Ytop A
	LDA $14D4,x	;yhigh
	XBA
	LDA $D8,x	;ylow
	REP #$20	;16bit A
	CLC
	ADC.w #YDISPS	;add displacement word
	CLC
	ADC $04
	CMP $96		;compare mario y
	SEP #$20	;8bit A again
	BCS VertTopOut	;if Mario's Y is smaller, then mario is ? of sprite

;Ytop B
	LDA $14D4,x	;load x positions again
	XBA
	LDA $D8,x
	REP #$20	;16bit A
	CLC
	ADC.w #YDISPS	;add width, test right
	CLC
	ADC.w #$0006	;6px 'bufferzone'
	CLC
	ADC $04
	STA $00		;scratch
	LDA $96		;load mario X
	CMP $00		;compare operated value
	SEP #$20	;8bit A again
	BCS VertTopOut

	LDA #$02	;within vertical top range
	TSB $02
	JMP SkipVerts

VertTopOut		;not in YTop, try Y center
;test Ycent A
	LDA $14D4,x	;yhigh
	XBA
	LDA $D8,x	;ylow
	REP #$20	;16bit A
	CLC
	ADC.w #YDISPS	;add displacement word
	CLC
	ADC.w #$0006	;add 6 px
	CLC
	ADC $04
	CMP $96		;compare mario y
	SEP #$20	;8bit A again
	BCS VertCentOut	;if Mario's Y is smaller, then mario is ? of sprite

;Ycent B
	LDA $14D4,x	;load x positions again
	XBA
	LDA $D8,x
	REP #$20	;16bit A
	CLC
	ADC.w #YDISPS	;add width, test right
	CLC
	ADC.w #HEIGHT	;add height
	SEC
	SBC.w #$0006	;6px 'buffer zone' too
	CLC
	ADC.w #$0010	;16px
	CLC
	ADC $04
	STA $00		;scratch
	LDA $96		;load mario X
	CMP $00		;compare operated value
	SEP #$20	;8bit A again
	BCS VertCentOut

	LDA #$04	;within vertical cent range
	TSB $02
	BRA SkipVerts

VertCentOut		;not in Ycent, try Y bottom
	LDA $14D4,x	;yhigh
	XBA
	LDA $D8,x	;ylow
	REP #$20	;16bit A
	CLC
	ADC.w #YDISPS	;add displacement word
	CLC
	ADC.w #HEIGHT
	CLC
	ADC.w #$0010	;add 16px, since it's relative to mario's head instead of his feet here
	SEC
	SBC.w #$0006	;sub 6px buffer
	CLC
	ADC $04
	CMP $96		;compare mario y
	SEP #$20	;8bit A again
	BCS SkipVerts

;Ybot B
	LDA $14D4,x	;load x positions again
	XBA
	LDA $D8,x
	REP #$20	;16bit A
	CLC
	ADC.w #YDISPS	;add width, test right
	CLC
	ADC.w #HEIGHT	;add height
	CLC
	ADC.w #$0016	;add 16px for marios head again
	CLC
	ADC $04
	STA $00		;scratch
	LDA $96		;load mario X
	CMP $00		;compare operated value
	SEP #$20	;8bit A again
	BCS SkipVerts

	LDA #$08	;within vertical bottom range
	TSB $02

SkipVerts
;rising mario

;placement on top of sprite
	LDA $02		;test 2 bits for X range and Y top
	AND #$03	;low 2 bits
	CMP #$03
	BEQ HandleStand	;handle mario standingon platform

	LDA $02
	AND #$05	;test xrange and ycent
	CMP #$05
	BEQ HandleCent

	LDA $02
	AND #$09	;test xbottom and ybottom
	CMP #$09
	BEQ HandleBumpHead

	JMP ReturnSLD	;bottom out

HandleCent
	JSR SUB_HORZ_POS	;get side of sprite mario is on
	CPY #$00	;compare result
	BEQ MarioLeftRight

;Marioleftright
	LDA $7B		;load xspd
	BMI NoClipXY	;don't clip if going in direction that isn't blocked
	STZ $7B		;clip if required
	JMP ReturnSLD	;ret

MarioLeftRight
	LDA $7B		;load xspd
	BPL NoClipXY
	STZ $7B	
	JMP ReturnSLD	;ret

NoClipXY
	JMP ReturnSLD	;return

HandleBumpHead
	LDA $7D		;if rising, set falling speed
	BPL DontClipYS
	LDA #$08	;set falling speed
	STA $7D
DontClipYS
	JMP ReturnSLD	;return

HandleStand
	LDA $7D		;mario Y
	BPL FallingMario

	;handle bumping from the underside if needed
	BRA ReturnSLD	;TEMP: return
	
FallingMario
	SEP #$20	;8bit A
	LDA #$01	;set riding sprite
	STA $1471
	STZ $7D		;no Yspd

	LDY #$E0	;displacement no yoshi
	LDA $187A	;yoshi flag
	BEQ NoYoshiA
	LDY #$D0	;displacement yoshi
NoYoshiA
	INY
	TYA		;chosen displacement to A
	CLC
	ADC $D8,x	;sprite y lo
	STA $96		;mario y lo
	LDA $14D4,x	;sprite y hi
	ADC #$FF	;inverse carry
	STA $97

ReturnSLD
	PLP		;restore status
	RTS

;=================
;BORROWED ROUTINES
;=================

;GET_DRAW_INFO
;==============

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SPR_T1              dcb $0C,$1C
SPR_T2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC SPR_T1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA SPR_T2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /
	

;SUBHORZPOS
;==========

SUB_HORZ_POS        LDY #$00                ;A:25D0 X:0006 Y:0001 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1020 VC:097 00 FL:31642
                    SEP #$20
                    LDA $94                 ;A:25D0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:envMXdiZCHC:1036 VC:097 00 FL:31642
                    SEC                     ;A:25F0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1060 VC:097 00 FL:31642
                    SBC $E4,x               ;A:25F0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1074 VC:097 00 FL:31642
                    STA $0E                 ;A:25F4 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1104 VC:097 00 FL:31642
                    LDA $95                 ;A:25F4 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1128 VC:097 00 FL:31642
                    SBC $14E0,x             ;A:2500 X:0006 Y:0000 D:0000 DB:03 S:01ED P:envMXdiZcHC:1152 VC:097 00 FL:31642
                    BPL LABEL16             ;A:25FF X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1184 VC:097 00 FL:31642
                    INY                     ;A:25FF X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1200 VC:097 00 FL:31642
LABEL16             RTS                     ;A:25FF X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdizcHC:1214 VC:097 00 FL:31642

;SUBVERTPOS
;==========

SUB_VERT_POS        LDY #$00               ;A:25A1 X:0007 Y:0001 D:0000 DB:03 S:01EA P:envMXdizCHC:0130 VC:085 00 FL:924
                    LDA $96                ;A:25A1 X:0007 Y:0000 D:0000 DB:03 S:01EA P:envMXdiZCHC:0146 VC:085 00 FL:924
                    SEC                    ;A:2546 X:0007 Y:0000 D:0000 DB:03 S:01EA P:envMXdizCHC:0170 VC:085 00 FL:924
                    SBC $D8,x              ;A:2546 X:0007 Y:0000 D:0000 DB:03 S:01EA P:envMXdizCHC:0184 VC:085 00 FL:924
                    STA $0F                ;A:25D6 X:0007 Y:0000 D:0000 DB:03 S:01EA P:eNvMXdizcHC:0214 VC:085 00 FL:924
                    LDA $97                ;A:25D6 X:0007 Y:0000 D:0000 DB:03 S:01EA P:eNvMXdizcHC:0238 VC:085 00 FL:924
                    SBC $14D4,x            ;A:2501 X:0007 Y:0000 D:0000 DB:03 S:01EA P:envMXdizcHC:0262 VC:085 00 FL:924
                    BPL LABEL11            ;A:25FF X:0007 Y:0000 D:0000 DB:03 S:01EA P:eNvMXdizcHC:0294 VC:085 00 FL:924
                    INY                    ;A:25FF X:0007 Y:0000 D:0000 DB:03 S:01EA P:eNvMXdizcHC:0310 VC:085 00 FL:924
LABEL11             RTS                    ;A:25FF X:0007 Y:0001 D:0000 DB:03 S:01EA P:envMXdizcHC:0324 VC:085 00 FL:924

;smoke...
SUB_SMOKE           LDY #$03                ; \ find a free slot to display effect
FINDFREE            LDA $17C0,y             ;  |
                    BEQ FOUNDONE            ;  |
                    DEY                     ;  |
                    BPL FINDFREE            ;  |
                    RTS                     ; / return if no slots open

FOUNDONE            LDA #$01                ; \ set effect graphic to smoke graphic
                    STA $17C0,y             ; /
                    LDA $01               ; \ smoke y position = generator y position
                    STA $17C4,y             ; /
                    LDA #$18                ; \ set time to show smoke
                    STA $17CC,y             ; /
                    LDA $00               ; \ load generator x position and store it for later
                    STA $17C8,y             ; /
                    LDX $15E9
             
                    RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; SUB_OFF_SCREEN
; This subroutine deals with sprites that have moved off screen
; It is adapted from the subroutine at $01AC0D
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                    
SPR_T12             dcb $40,$B0
SPR_T13             dcb $01,$FF
SPR_T14             dcb $30,$C0,$A0,$C0,$A0,$F0,$60,$90		;bank 1 sizes
		            dcb $30,$C0,$A0,$80,$A0,$40,$60,$B0		;bank 3 sizes
SPR_T15             dcb $01,$FF,$01,$FF,$01,$FF,$01,$FF		;bank 1 sizes
					dcb $01,$FF,$01,$FF,$01,$00,$01,$FF		;bank 3 sizes

SUB_OFF_SCREEN_X1   LDA #$02                ; \ entry point of routine determines value of $03
                    BRA STORE_03            ;  | (table entry to use on horizontal levels)
SUB_OFF_SCREEN_X2   LDA #$04                ;  | 
                    BRA STORE_03            ;  |
SUB_OFF_SCREEN_X3   LDA #$06                ;  |
                    BRA STORE_03            ;  |
SUB_OFF_SCREEN_X4   LDA #$08                ;  |
                    BRA STORE_03            ;  |
SUB_OFF_SCREEN_X5   LDA #$0A                ;  |
                    BRA STORE_03            ;  |
SUB_OFF_SCREEN_X6   LDA #$0C                ;  |
                    BRA STORE_03            ;  |
SUB_OFF_SCREEN_X7   LDA #$0E                ;  |
STORE_03			STA $03					;  |            
					BRA START_SUB			;  |
SUB_OFF_SCREEN_X0   STZ $03					; /

START_SUB           JSR SUB_IS_OFF_SCREEN   ; \ if sprite is not off screen, return
                    BEQ RETURN_35           ; /
                    LDA $5B                 ; \  goto VERTICAL_LEVEL if vertical level
                    AND #$01                ; |
                    BNE VERTICAL_LEVEL      ; /     
                    LDA $D8,x               ; \
                    CLC                     ; | 
                    ADC #$50                ; | if the sprite has gone off the bottom of the level...
                    LDA $14D4,x             ; | (if adding 0x50 to the sprite y position would make the high byte >= 2)
                    ADC #$00                ; | 
                    CMP #$02                ; | 
                    BPL ERASE_SPRITE        ; /    ...erase the sprite
                    LDA $167A,x             ; \ if "process offscreen" flag is set, return
                    AND #$04                ; |
                    BNE RETURN_35           ; /
                    LDA $13                 ;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZcHC:0756 VC:176 00 FL:205
                    AND #$01                ;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0780 VC:176 00 FL:205
                    ORA $03                 ;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0796 VC:176 00 FL:205
                    STA $01                 ;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0820 VC:176 00 FL:205
                    TAY                     ;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0844 VC:176 00 FL:205
                    LDA $1A                 ;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0858 VC:176 00 FL:205
                    CLC                     ;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZcHC:0882 VC:176 00 FL:205
                    ADC SPR_T14,y           ;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZcHC:0896 VC:176 00 FL:205
                    ROL $00                 ;A:8AC0 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:eNvMXdizcHC:0928 VC:176 00 FL:205
                    CMP $E4,x               ;A:8AC0 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:eNvMXdizCHC:0966 VC:176 00 FL:205
                    PHP                     ;A:8AC0 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:0996 VC:176 00 FL:205
                    LDA $1B                 ;A:8AC0 X:0009 Y:0001 D:0000 DB:01 S:01F0 P:envMXdizCHC:1018 VC:176 00 FL:205
                    LSR $00                 ;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F0 P:envMXdiZCHC:1042 VC:176 00 FL:205
                    ADC SPR_T15,y           ;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F0 P:envMXdizcHC:1080 VC:176 00 FL:205
                    PLP                     ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F0 P:eNvMXdizcHC:1112 VC:176 00 FL:205
                    SBC $14E0,x             ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:1140 VC:176 00 FL:205
                    STA $00                 ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:eNvMXdizCHC:1172 VC:176 00 FL:205
                    LSR $01                 ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:eNvMXdizCHC:1196 VC:176 00 FL:205
                    BCC SPR_L31             ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZCHC:1234 VC:176 00 FL:205
                    EOR #$80                ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZCHC:1250 VC:176 00 FL:205
                    STA $00                 ;A:8A7F X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:1266 VC:176 00 FL:205
SPR_L31             LDA $00                 ;A:8A7F X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:1290 VC:176 00 FL:205
                    BPL RETURN_35           ;A:8A7F X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:1314 VC:176 00 FL:205
ERASE_SPRITE        LDA $14C8,x             ; \ if sprite status < 8, permanently erase sprite
                    CMP #$08                ; |
                    BCC KILL_SPRITE         ; /    
                    LDY $161A,x             ;A:FF08 X:0007 Y:0001 D:0000 DB:01 S:01F3 P:envMXdiZCHC:1108 VC:059 00 FL:2878
                    CPY #$FF                ;A:FF08 X:0007 Y:0000 D:0000 DB:01 S:01F3 P:envMXdiZCHC:1140 VC:059 00 FL:2878
                    BEQ KILL_SPRITE         ;A:FF08 X:0007 Y:0000 D:0000 DB:01 S:01F3 P:envMXdizcHC:1156 VC:059 00 FL:2878
                    LDA #$00                ;A:FF08 X:0007 Y:0000 D:0000 DB:01 S:01F3 P:envMXdizcHC:1172 VC:059 00 FL:2878
                    STA $1938,y             ;A:FF00 X:0007 Y:0000 D:0000 DB:01 S:01F3 P:envMXdiZcHC:1188 VC:059 00 FL:2878
KILL_SPRITE         STZ $14C8,x             ; erase sprite
RETURN_35           RTS                     ; return

VERTICAL_LEVEL      LDA $167A,x             ; \ if "process offscreen" flag is set, return
                    AND #$04                ; |
                    BNE RETURN_35           ; /
                    LDA $13                 ; \
                    LSR A                   ; | 
                    BCS RETURN_35           ; /
                    LDA $E4,x               ; \ 
                    CMP #$00                ;  | if the sprite has gone off the side of the level...
                    LDA $14E0,x             ;  |
                    SBC #$00                ;  |
                    CMP #$02                ;  |
                    BCS ERASE_SPRITE        ; /  ...erase the sprite
                    LDA $13                 ;A:0000 X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:1218 VC:250 00 FL:5379
                    LSR A                   ;A:0016 X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:envMXdizcHC:1242 VC:250 00 FL:5379
                    AND #$01                ;A:000B X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:envMXdizcHC:1256 VC:250 00 FL:5379
                    STA $01                 ;A:0001 X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:envMXdizcHC:1272 VC:250 00 FL:5379
                    TAY                     ;A:0001 X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:envMXdizcHC:1296 VC:250 00 FL:5379
                    LDA $1C                 ;A:001A X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0052 VC:251 00 FL:5379
                    CLC                     ;A:00BD X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0076 VC:251 00 FL:5379
                    ADC SPR_T12,y           ;A:00BD X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0090 VC:251 00 FL:5379
                    ROL $00                 ;A:006D X:0009 Y:0001 D:0000 DB:01 S:01F3 P:enVMXdizCHC:0122 VC:251 00 FL:5379
                    CMP $D8,x               ;A:006D X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNVMXdizcHC:0160 VC:251 00 FL:5379
                    PHP                     ;A:006D X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNVMXdizcHC:0190 VC:251 00 FL:5379
                    LDA.W $001D             ;A:006D X:0009 Y:0001 D:0000 DB:01 S:01F2 P:eNVMXdizcHC:0212 VC:251 00 FL:5379
                    LSR $00                 ;A:0000 X:0009 Y:0001 D:0000 DB:01 S:01F2 P:enVMXdiZcHC:0244 VC:251 00 FL:5379
                    ADC SPR_T13,y           ;A:0000 X:0009 Y:0001 D:0000 DB:01 S:01F2 P:enVMXdizCHC:0282 VC:251 00 FL:5379
                    PLP                     ;A:0000 X:0009 Y:0001 D:0000 DB:01 S:01F2 P:envMXdiZCHC:0314 VC:251 00 FL:5379
                    SBC $14D4,x             ;A:0000 X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNVMXdizcHC:0342 VC:251 00 FL:5379
                    STA $00                 ;A:00FF X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0374 VC:251 00 FL:5379
                    LDY $01                 ;A:00FF X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0398 VC:251 00 FL:5379
                    BEQ SPR_L38             ;A:00FF X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0422 VC:251 00 FL:5379
                    EOR #$80                ;A:00FF X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0438 VC:251 00 FL:5379
                    STA $00                 ;A:007F X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0454 VC:251 00 FL:5379
SPR_L38             LDA $00                 ;A:007F X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0478 VC:251 00 FL:5379
                    BPL RETURN_35           ;A:007F X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0502 VC:251 00 FL:5379
                    BMI ERASE_SPRITE        ;A:8AFF X:0002 Y:0000 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0704 VC:184 00 FL:5490

SUB_IS_OFF_SCREEN   LDA $15A0,x             ; \ if sprite is on screen, accumulator = 0 
                    ORA $186C,x             ; |  
                    RTS                     ; / return